[dp]Educational Codeforces Round 12 C. Simple Strings

题目

zscoder loves simple strings! A string t is called simple if every pair of adjacent characters are distinct. For example ab, aba, zscoder are simple whereas aa, add are not simple.

zscoder is given a string s. He wants to change a minimum number of characters so that the string s becomes simple. Help him with this task!

Input
The only line contains the string s (1 ≤ |s| ≤ 2·105) — the string given to zscoder. The string s consists of only lowercase English letters.

Output
Print the simple string s’ — the string s after the minimal number of changes. If there are multiple solutions, you may output any of them.

Note that the string s’ should also consist of only lowercase English letters.

Examples
inputCopy
aab
outputCopy
bab
inputCopy
caaab
outputCopy
cabab
inputCopy
zscoder
outputCopy
zscoder

题目大意:给定一个字符串要求修改最少的字符,使得修改之后的字符串,相邻的字符不同。输出修改后的字符串。
用dp去构造,每个位置可以是26个字母中的任意一个。所以,用dp[i][j]修改s串为Simple Strings所需的最少修改次数。那么dp[i][j] = dp[i-1][k] + cost 如果,字母j在s中,那么cost = 0否则为1。 最后根据记录的路径输出一个构造好的Simple String, 代码如下

/* ***********************************************
Author        :[email protected]
Created Time  :2018年07月07日 星期六 11时58分54秒
File Name     :0371.cpp
************************************************ */
#include <bits/stdc++.h>
using namespace std;
const int N = 200010;
const int inf = 0x3f3f3f3f;
int dp[N][27];
int pre[N][27];
string s;

int main() {
    while (cin >> s) {
        memset(dp, inf, sizeof dp);
        memset(pre, 0, sizeof pre);
        for (int i = 0; i < 26; ++i) dp[0][i] = 1;
        dp[0][s[0]-'a'] = 0;
        for (int i = 1; i < s.size(); ++i) {
            int c = s[i]-'a';
            for (int j = 0; j < 26; ++j) {
                if (j > inf/2)continue;
                for (int k = 0; k < 26; ++k) {
                    if (j == k) continue;
                    int cost = c != j;
                    //cout << cost << " " << c << " " << k << endl;
                    if (dp[i-1][k] + cost < dp[i][j]) {
                        dp[i][j] = dp[i-1][k] + cost;
                        pre[i][j] = k;
                    }
                }
            }
        }
        int ans = inf;
        int b = 0;
        for (int i = 0; i < 26; ++i) {
            //cout << dp[s.size()-1][i] << endl;
            if (dp[s.size()-1][i] < ans) {
                ans = dp[s.size()-1][i];
                b = i;
            }
        }
        int i,j;
        for (i = s.size()-1, j = b; i >= 0; j = pre[i][j],--i) {
            s[i] = 'a' + j;
        }
        cout << s << endl;  
    }   
    return 0;
}

猜你喜欢

转载自blog.csdn.net/u013077144/article/details/80966057